/* 
   Host infomation wrapper
   Copyright (C) 2003-2004, Lei Jiang <sledge10@hotmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: DavHost.h 132 2005-06-24 09:09:43Z komat $
*/

#ifndef ONION_HEADER_DAVHOST_H
#define ONION_HEADER_DAVHOST_H 1

#include <onion/OnionCfg.h>

/**CDavHost is a wrapper to hold details
 * regarding how to locate a dav server
 */
OI_BEGIN_CLASSEXPORT

class OI_EXPORT CDavHost
{
 public:
  CDavHost();
  CDavHost(const char *pszName, unsigned short usPort);
  CDavHost(const CDavHost& old);
  ~CDavHost(void);
  const char* GetHostName();
  unsigned short GetPort();
  void SetHostName(const char *pszName);
  void SetPort(unsigned short usPort);
  CDavHost& operator=(const CDavHost& old);
 private:
  OI_STRING_A m_strHostName;
  unsigned short m_usPort;
  void copy(const CDavHost& old);
};

OI_END_CLASSEXPORT

#endif /*ONION_HEADER_DAVHOST_H*/
