/* 
   Interface of socket I/O methods
   Copyright (C) 2003-2004, Lei Jiang <sledge10@hotmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: IDavSocketIO.h 132 2005-06-24 09:09:43Z komat $
*/

#ifndef ONION_HEADER_IDAVSOCKETIO_H
#define ONION_HEADER_IDAVSOCKETIO_H 1

#include <onion/OnionCfg.h>

//forward declarations
class CDavSocket;

OI_BEGIN_CLASSEXPORT

class OI_EXPORT IDavSocketIO
{
 public:
  virtual OI_RESULT Readable(CDavSocket* pSocket,
			     int nSecs) = 0;
  virtual OI_RESULT Read(CDavSocket* pSocket,
			 char* pszBuf,
			 size_t* punReadLen,
			 int nSecs) = 0;
  virtual OI_RESULT Write(CDavSocket* pSocket,
			  const char* pszBuf,
			  size_t* punWrittenLen) = 0;
};

OI_END_CLASSEXPORT

#endif /*ONION_HEADER_IDAVSOCKETIO_H*/
