/* 
   Response body consumer that parses body as an XML stream
   Copyright (C) 2003-2004, Lei Jiang <sledge10@hotmail.com>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA

   $Id: PBCSMXml.h 132 2005-06-24 09:09:43Z komat $
*/


#ifndef ONION_HEADER_PBCSMXML_H
#define ONION_HEADER_PBCSMXML_H 1

#include <onion/OnionCfg.h>
#include <onion/ResponseBodyConsumer.h>
#include <xercesc/dom/DOM.hpp>

//forward declarations
class CDavXmlBuffer;
class CDavXmlErrorHandler;
class CDavXmlParser;

OI_BEGIN_CLASSEXPORT

class OI_EXPORT CPBCSMXml : public CResponseBodyConsumer
{
 public:
  CPBCSMXml(CDavRequest* pReq,
	    const char* pszCutElement = NULL,
	    CDavXmlBuffer* pXmlReceiver = NULL);
  virtual ~CPBCSMXml();

  virtual void Close();
  virtual OI_RESULT Open();
  virtual OI_PBC_TYPE GetType();
  virtual OI_RESULT CheckCType(const char* pszCType);
  virtual OI_RESULT PullResponseBody(CDavResponseBody* pBody);

  virtual void OnResponseFound(XNS(DOMNode)* pNode);
  XNS(DOMDocument)* GetDocument();
 private:
  OI_RESULT m_enuError;
  OI_STRING_A m_strCutElement;
  CDavXmlErrorHandler* m_pErrorHandler;
  CDavXmlParser* m_pXmlParser;
  CDavXmlBuffer* m_pXmlReceiver;
  int m_nResponseCounter;
};

OI_END_CLASSEXPORT

#endif /*ONION_HEADER_PBCSMXML_H*/
